Index: django/conf/locale/es_AR/formats.py
===================================================================
--- django/conf/locale/es_AR/formats.py	(Revision 12613)
+++ django/conf/locale/es_AR/formats.py	(Arbeitskopie)
@@ -4,7 +4,7 @@
 
 DATE_FORMAT = 'j \\de F \\de Y'
 TIME_FORMAT = 'H:i:s'
-DATETIME_FORMAT = 'j \\de F \\de Y \\a \\l\\a\s H:i'
+DATETIME_FORMAT = 'j \\de F \\de Y \\a \\l\\a\\s H:i'
 YEAR_MONTH_FORMAT = 'F \\de Y'
 MONTH_DAY_FORMAT = 'j \\de F'
 SHORT_DATE_FORMAT = 'd/m/Y'
Index: django/conf/locale/vi/formats.py
===================================================================
--- django/conf/locale/vi/formats.py	(Revision 12613)
+++ django/conf/locale/vi/formats.py	(Arbeitskopie)
@@ -2,9 +2,9 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = '\N\gà\y d \t\há\n\g n \nă\m Y'
+DATE_FORMAT = r'\N\gà\y d \t\há\n\g n \nă\m Y'
 TIME_FORMAT = 'H:i:s'
-DATETIME_FORMAT = 'H:i:s \N\gà\y d \t\há\n\g n \nă\m Y'
+DATETIME_FORMAT = r'H:i:s \N\gà\y d \t\há\n\g n \nă\m Y'
 YEAR_MONTH_FORMAT = 'F Y'
 MONTH_DAY_FORMAT = 'j F'
 SHORT_DATE_FORMAT = 'd-m-Y'
Index: django/conf/locale/lt/formats.py
===================================================================
--- django/conf/locale/lt/formats.py	(Revision 12613)
+++ django/conf/locale/lt/formats.py	(Arbeitskopie)
@@ -2,7 +2,7 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'Y \m. F j \d.'
+DATE_FORMAT = r'Y \m. F j \d.'
 TIME_FORMAT = 'H:i:s'
 # DATETIME_FORMAT = 
 # YEAR_MONTH_FORMAT = 
Index: django/conf/locale/lv/formats.py
===================================================================
--- django/conf/locale/lv/formats.py	(Revision 12613)
+++ django/conf/locale/lv/formats.py	(Arbeitskopie)
@@ -2,12 +2,12 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'Y. \g\a\d\a j. F'
+DATE_FORMAT = r'Y. \g\a\d\a j. F'
 TIME_FORMAT = 'H:i:s'
 # DATETIME_FORMAT = 
-YEAR_MONTH_FORMAT = 'Y. \g. F'
+YEAR_MONTH_FORMAT = r'Y. \g. F'
 MONTH_DAY_FORMAT = 'j. F'
-SHORT_DATE_FORMAT = 'Y. \g\a\d\a j. M'
+SHORT_DATE_FORMAT = r'Y. \g\a\d\a j. M'
 # SHORT_DATETIME_FORMAT = 
 # FIRST_DAY_OF_WEEK = 
 # DATE_INPUT_FORMATS = 
Index: django/conf/locale/pt/formats.py
===================================================================
--- django/conf/locale/pt/formats.py	(Revision 12613)
+++ django/conf/locale/pt/formats.py	(Arbeitskopie)
@@ -2,11 +2,11 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j \de F \de Y'
+DATE_FORMAT = r'j \de F \de Y'
 TIME_FORMAT = 'H:i:s'
 # DATETIME_FORMAT = 
-YEAR_MONTH_FORMAT = 'F \de Y'
-MONTH_DAY_FORMAT = 'j \de F'
+YEAR_MONTH_FORMAT = r'F \de Y'
+MONTH_DAY_FORMAT = r'j \de F'
 SHORT_DATE_FORMAT = 'd/m/Y'
 # SHORT_DATETIME_FORMAT = 
 # FIRST_DAY_OF_WEEK = 
Index: django/conf/locale/ca/formats.py
===================================================================
--- django/conf/locale/ca/formats.py	(Revision 12613)
+++ django/conf/locale/ca/formats.py	(Arbeitskopie)
@@ -2,11 +2,11 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j \de F \de Y'
+DATE_FORMAT = r'j \de F \de Y'
 TIME_FORMAT = 'G:i:s'
-DATETIME_FORMAT = 'j \de F \de Y \\a \le\s G:i'
-YEAR_MONTH_FORMAT = 'F \de\l Y'
-MONTH_DAY_FORMAT = 'j \de F'
+DATETIME_FORMAT = r'j \de F \de Y \a \le\s G:i'
+YEAR_MONTH_FORMAT = r'F \de\l Y'
+MONTH_DAY_FORMAT = r'j \de F'
 SHORT_DATE_FORMAT = 'd/m/Y'
 SHORT_DATETIME_FORMAT = 'd/m/Y G:i'
 FIRST_DAY_OF_WEEK = 1 # Monday
Index: django/conf/locale/es/formats.py
===================================================================
--- django/conf/locale/es/formats.py	(Revision 12613)
+++ django/conf/locale/es/formats.py	(Arbeitskopie)
@@ -2,11 +2,11 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'j \de F \de Y'
+DATE_FORMAT = r'j \de F \de Y'
 TIME_FORMAT = 'H:i:s'
-DATETIME_FORMAT = 'j \de F \de Y \a \l\a\s H:i'
-YEAR_MONTH_FORMAT = 'F \de Y'
-MONTH_DAY_FORMAT = 'j \de F'
+DATETIME_FORMAT = r'j \de F \de Y \a \l\a\s H:i'
+YEAR_MONTH_FORMAT = r'F \de Y'
+MONTH_DAY_FORMAT = r'j \de F'
 SHORT_DATE_FORMAT = 'd/m/Y'
 SHORT_DATETIME_FORMAT = 'd/m/Y H:i'
 FIRST_DAY_OF_WEEK = 1 # Monday
Index: django/conf/locale/eu/formats.py
===================================================================
--- django/conf/locale/eu/formats.py	(Revision 12613)
+++ django/conf/locale/eu/formats.py	(Arbeitskopie)
@@ -2,7 +2,7 @@
 # This file is distributed under the same license as the Django package.
 #
 
-DATE_FORMAT = 'Yeko M\re\n d\a'
+DATE_FORMAT = r'Yeko M\re\n d\a'
 TIME_FORMAT = 'H:i:s'
 # DATETIME_FORMAT = 
 # YEAR_MONTH_FORMAT = 