diff --git a/docs/ref/models/querysets.txt b/docs/ref/models/querysets.txt
--- a/docs/ref/models/querysets.txt
+++ b/docs/ref/models/querysets.txt
@@ -138,6 +138,8 @@
 ``filter(**kwargs)``
 ~~~~~~~~~~~~~~~~~~~~
 
+.. method:: filter(**kwargs)
+
 Returns a new ``QuerySet`` containing objects that match the given lookup
 parameters.
 
@@ -148,6 +150,8 @@
 ``exclude(**kwargs)``
 ~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: exclude(**kwargs)
+
 Returns a new ``QuerySet`` containing objects that do *not* match the given
 lookup parameters.
 
@@ -181,6 +185,8 @@
 ``annotate(*args, **kwargs)``
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: annotate(*args, **kwargs)
+
 .. versionadded:: 1.1
 
 Annotates each object in the ``QuerySet`` with the provided list of
@@ -223,6 +229,8 @@
 ``order_by(*fields)``
 ~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: order_by(*fields)
+
 By default, results returned by a ``QuerySet`` are ordered by the ordering
 tuple given by the ``ordering`` option in the model's ``Meta``. You can
 override this on a per-``QuerySet`` basis by using the ``order_by`` method.
@@ -297,6 +305,8 @@
 ``reverse()``
 ~~~~~~~~~~~~~
 
+.. method:: reverse()
+
 .. versionadded:: 1.0
 
 Use the ``reverse()`` method to reverse the order in which a queryset's
@@ -327,6 +337,8 @@
 ``distinct()``
 ~~~~~~~~~~~~~~
 
+.. method:: distinct()
+
 Returns a new ``QuerySet`` that uses ``SELECT DISTINCT`` in its SQL query. This
 eliminates duplicate rows from the query results.
 
@@ -361,6 +373,8 @@
 ``values(*fields)``
 ~~~~~~~~~~~~~~~~~~~
 
+.. method:: values(*fields)
+
 Returns a ``ValuesQuerySet`` -- a ``QuerySet`` that returns dictionaries when
 used as an iterable, rather than model-instance objects.
 
@@ -444,6 +458,8 @@
 ``values_list(*fields)``
 ~~~~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: values_list(*fields)
+
 .. versionadded:: 1.0
 
 This is similar to ``values()`` except that instead of returning dictionaries,
@@ -472,6 +488,8 @@
 ``dates(field, kind, order='ASC')``
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: dates(field, kind, order='ASC')
+
 Returns a ``DateQuerySet`` -- a ``QuerySet`` that evaluates to a list of
 ``datetime.datetime`` objects representing all available dates of a particular
 kind within the contents of the ``QuerySet``.
@@ -506,6 +524,8 @@
 ``none()``
 ~~~~~~~~~~
 
+.. method:: none()
+
 .. versionadded:: 1.0
 
 Returns an ``EmptyQuerySet`` -- a ``QuerySet`` that always evaluates to
@@ -519,7 +539,9 @@
     []
 
 ``all()``
-~~~~~~~~~~
+~~~~~~~~~
+
+.. method:: all()
 
 .. versionadded:: 1.0
 
@@ -534,6 +556,8 @@
 ``select_related()``
 ~~~~~~~~~~~~~~~~~~~~
 
+.. method:: select_related()
+
 Returns a ``QuerySet`` that will automatically "follow" foreign-key
 relationships, selecting that additional related-object data when it executes
 its query. This is a performance booster which results in (sometimes much)
@@ -655,6 +679,8 @@
 ``extra(select=None, where=None, params=None, tables=None, order_by=None, select_params=None)``
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: extra(select=None, where=None, params=None, tables=None, order_by=None, select_params=None)
+
 Sometimes, the Django query syntax by itself can't easily express a complex
 ``WHERE`` clause. For these edge cases, Django provides the ``extra()``
 ``QuerySet`` modifier -- a hook for injecting specific clauses into the SQL
@@ -817,6 +843,8 @@
 ``defer(*fields)``
 ~~~~~~~~~~~~~~~~~~
 
+.. method:: defer(*fields)
+
 .. versionadded:: 1.1
 
 In some complex data-modeling situations, your models might contain a lot of
@@ -873,7 +901,9 @@
     settled down and you understand where the hot-points are.
 
 ``only(*fields)``
-~~~~~~~~~~~~~~~~~~
+~~~~~~~~~~~~~~~~~
+
+.. method:: only(*fields)
 
 .. versionadded:: 1.1
 
@@ -909,7 +939,9 @@
     Entry.objects.defer("body").only("headline", "body")
 
 ``using(alias)``
-~~~~~~~~~~~~~~~~~~
+~~~~~~~~~~~~~~~~
+
+.. method:: using(alias)
 
 .. versionadded:: 1.2
 
@@ -941,6 +973,8 @@
 ``get(**kwargs)``
 ~~~~~~~~~~~~~~~~~
 
+.. method:: get(**kwargs)
+
 Returns the object matching the given lookup parameters, which should be in
 the format described in `Field lookups`_.
 
@@ -968,6 +1002,8 @@
 ``create(**kwargs)``
 ~~~~~~~~~~~~~~~~~~~~
 
+.. method:: create(**kwargs)
+
 A convenience method for creating an object and saving it all in one step.  Thus::
 
     p = Person.objects.create(first_name="Bruce", last_name="Springsteen")
@@ -990,6 +1026,8 @@
 ``get_or_create(**kwargs)``
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: get_or_create(**kwargs)
+
 A convenience method for looking up an object with the given kwargs, creating
 one if necessary.
 
@@ -1058,6 +1096,8 @@
 ``count()``
 ~~~~~~~~~~~
 
+.. method:: count()
+
 Returns an integer representing the number of objects in the database matching
 the ``QuerySet``. ``count()`` never raises exceptions.
 
@@ -1082,6 +1122,8 @@
 ``in_bulk(id_list)``
 ~~~~~~~~~~~~~~~~~~~~
 
+.. method:: in_bulk(id_list)
+
 Takes a list of primary-key values and returns a dictionary mapping each
 primary-key value to an instance of the object with the given ID.
 
@@ -1101,6 +1143,8 @@
 ``iterator()``
 ~~~~~~~~~~~~~~
 
+.. method:: iterator()
+
 Evaluates the ``QuerySet`` (by performing the query) and returns an
 `iterator`_ over the results. A ``QuerySet`` typically caches its
 results internally so that repeated evaluations do not result in
@@ -1117,6 +1161,8 @@
 ``latest(field_name=None)``
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: latest(field_name=None)
+
 Returns the latest object in the table, by date, using the ``field_name``
 provided as the date field.
 
@@ -1137,6 +1183,8 @@
 ``aggregate(*args, **kwargs)``
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
+.. method:: aggregate(*args, **kwargs)
+
 .. versionadded:: 1.1
 
 Returns a dictionary of aggregate values (averages, sums, etc) calculated
@@ -1169,6 +1217,8 @@
 ``exists()``
 ~~~~~~~~~~~~
 
+.. method:: exists()
+
 .. versionadded:: 1.2
 
 Returns ``True`` if the :class:`QuerySet` contains any results, and ``False``